diff -ruN ../nakedmudv3.0/src/account_handler.c src/account_handler.c
--- ../nakedmudv3.0/src/account_handler.c	Fri Oct  7 14:15:55 2005
+++ src/account_handler.c	Sun Dec  4 20:03:08 2005
@@ -189,8 +189,11 @@
 
     // account created. Register it, and plop it into the account menu. If it
     // is already created, we're just editing the password. So save changes.
-    if(!account_exists(accountGetName(socketGetAccount(sock))))
+    if(!account_exists(accountGetName(socketGetAccount(sock)))) {
+      // run hooks for creating our account for the first time
+      hookRun("create_account", socketGetAccount(sock));
       register_account(socketGetAccount(sock));
+    }
     else
       save_account(socketGetAccount(sock));
     socketReplaceInputHandler(sock, account_handle_menu, account_menu);
@@ -245,7 +248,7 @@
 	socketSetChar(sock, NULL);
 	return;
       }
-
+      
       // try putting the character into the game. Pop the input handler
       // if we cannot
       if(try_enter_game(ch)) {
@@ -258,7 +261,7 @@
 	look_at_room(ch, charGetRoom(ch));
 
 	// run entrance hooks
-	hookRun("enter", ch, charGetRoom(ch), NULL);
+	hookRun("enter", ch, charGetRoom(ch));
       }
       else {
 	text_to_buffer(sock, "There was a problem entering the game. Try again later!\r\n");
diff -ruN ../nakedmudv3.0/src/action.c src/action.c
--- ../nakedmudv3.0/src/action.c	Fri Oct  7 14:15:55 2005
+++ src/action.c	Sun Dec  4 20:03:08 2005
@@ -112,11 +112,6 @@
 #endif
 }
 
-// stop_all_actions as a hook
-void stop_all_actions_hook(CHAR_DATA *ch, void *none1, void *none2) {
-  stop_all_actions(ch);
-}
-
 
 
 //*****************************************************************************
@@ -131,7 +126,7 @@
 	  "admin", TRUE, FALSE);
 
   // make sure the character does not continue actions after being extracted
-  hookAdd("char_from_game", stop_all_actions_hook);
+  hookAdd("char_from_game", stop_all_actions);
 }
 
 bool is_acting(void *ch, bitvector_t where) {
diff -ruN ../nakedmudv3.0/src/alias/.depend src/alias/.depend
--- ../nakedmudv3.0/src/alias/.depend	Wed Dec 31 17:00:00 1969
+++ src/alias/.depend	Sun Dec  4 20:03:07 2005
@@ -0,0 +1 @@
+alias.o: alias.c alias.h
diff -ruN ../nakedmudv3.0/src/alias/alias.c src/alias/alias.c
--- ../nakedmudv3.0/src/alias/alias.c	Fri Oct  7 14:15:55 2005
+++ src/alias/alias.c	Sun Dec  4 20:03:07 2005
@@ -158,7 +158,7 @@
   BUFFER *cmd = newBuffer(SMALL_BUFFER);
   func_depth++;
 
-  BUFFER *filled_alias = newBuffer(1);
+  BUFFER *filled_alias = newBuffer(MAX_BUFFER);
   bufferCat(filled_alias, alias);
   // now, replace all of our parameters 
   int i;
@@ -312,25 +312,25 @@
     if(alias == NULL)
       return FALSE;
     else {
-      BUFFER     *buf = expand_alias(ch, alias, arg);
-      int i, num_cmds = 0;
       // break the buffer contents up into multiple commands, if there are any
-      char     **cmds = parse_strings(bufferString(buf), ';', &num_cmds);
+      BUFFER     *buf = expand_alias(ch, alias, arg);
+      LIST      *cmds = parse_strings(bufferString(buf), ';');
+      char     *first = listPop(cmds);
       
       // queue all of our commands after the first onto the command list
-      if(charGetSocket(ch) && num_cmds > 1) {
-	for(i = 1; i < num_cmds; i++)
-	  socketQueueCommand(charGetSocket(ch), cmds[i]);
-	// note how many commands we got out of this alias
-	charSetAliasesQueued(ch, num_cmds);
+      if(charGetSocket(ch) && listSize(cmds) > 0) {
+	LIST_ITERATOR *cmd_i = newListIterator(cmds);
+	char            *cmd = NULL;
+	ITERATE_LIST(cmd, cmd_i) {
+	  socketQueueCommand(charGetSocket(ch), cmd);
+	} deleteListIterator(cmd_i);
+	charSetAliasesQueued(ch, listSize(cmds) + 1);
       }
-      if(num_cmds > 0)
-	do_cmd(ch, cmds[0], FALSE);
-      
-      // clean up our mess
-      for(i = 0; i < num_cmds; i++)
-	free(cmds[i]);
-      free(cmds);
+      if(first != NULL)
+	do_cmd(ch, first, FALSE);
+
+      deleteListWith(cmds, free);
+      if(first) free(first);
       deleteBuffer(buf);
       return TRUE;
     }
diff -ruN ../nakedmudv3.0/src/bitvector.c src/bitvector.c
--- ../nakedmudv3.0/src/bitvector.c	Fri Oct  7 14:15:55 2005
+++ src/bitvector.c	Sun Dec  4 20:03:08 2005
@@ -143,40 +143,34 @@
 }
 
 bool bitIsSet(BITVECTOR *v, const char *bit) {
-  // first, parse all of the names
-  bool found = FALSE;
-  int i, num_names = 0;
-  char **bits = parse_keywords(bit, &num_names);
+  LIST    *bits = parse_keywords(bit);
+  char *one_bit = NULL; 
+  bool    found = FALSE;
 
   // check for one
-  for(i = 0; i < num_names && !found; i++) {
-    found = bitIsOneSet(v, bits[i]);
-    free(bits[i]);
+  while( !found && (one_bit = listPop(bits)) != NULL) {
+    found = bitIsOneSet(v, one_bit);
+    free(one_bit);
   }
-
-  // continue our clean up
-  for(; i < num_names; i++)
-    free(bits[i]);
-  free(bits);
+  
+  // clean up our mess
+  deleteListWith(bits, free);
   return found;
 }
 
 bool bitIsAllSet(BITVECTOR *v, const char *bit) {
-  // first, parse all of the names
-  bool found = TRUE;
-  int i, num_names = 0;
-  char **bits = parse_keywords(bit, &num_names);
+  LIST    *bits = parse_keywords(bit);
+  char *one_bit = NULL;
+  bool    found = TRUE;
 
   // check for each one
-  for(i = 0; i < num_names && found; i++) {
-    found = bitIsOneSet(v, bits[i]);
-    free(bits[i]);
+  while( found && (one_bit = listPop(bits)) != NULL) {
+    found = bitIsOneSet(v, one_bit);
+    free(one_bit);
   }
 
-  // continue our clean up
-  for(; i < num_names; i++)
-    free(bits[i]);
-  free(bits);
+  // clean up our mess
+  deleteListWith(bits, free);
   return found;
 }
 
@@ -186,19 +180,20 @@
 }
 
 void bitSet(BITVECTOR *v, const char *name) {
-  // first, parse all of the names
-  int i, num_names = 0;
-  char **bits = parse_keywords(name, &num_names);
+  LIST    *bits = parse_keywords(name);
+  char *one_bit = NULL;
 
   // set each one
-  for(i = 0; i < num_names; i++) {
-    int val = (int)hashGet(v->data->bitmap, bits[i]);
-    free(bits[i]);
+  while( (one_bit = listPop(bits)) != NULL) {
+    int val = (int)hashGet(v->data->bitmap, one_bit);
+    free(one_bit);
     // 0 is a filler meaning 'this is not an actual name for a bit'
     if(val == 0) continue;
     SET_BIT(v->bits[val/8], (1 << (val % 8)));
   }
-  free(bits);
+
+  // garbage collection
+  deleteListWith(bits, free);
 }
 
 void bitClear(BITVECTOR *v) {
@@ -208,33 +203,35 @@
 }
 
 void bitRemove(BITVECTOR *v, const char *name) {
-  // first, parse all of the names
-  int i, num_names = 0;
-  char **bits = parse_keywords(name, &num_names);
+  LIST    *bits = parse_keywords(name);
+  char *one_bit = NULL;
 
-  // set each one
-  for(i = 0; i < num_names; i++) {
-    int val = (int)hashGet(v->data->bitmap, bits[i]);
+  // remove each one
+  while( (one_bit = listPop(bits)) != NULL) {
+    int val = (int)hashGet(v->data->bitmap, one_bit);
     REMOVE_BIT(v->bits[val/8], (1 << (val % 8)));
-    free(bits[i]);
+    free(one_bit);
   }
-  free(bits);
+
+  // garbage collection
+  deleteListWith(bits, free);
 }
 
 void bitToggle(BITVECTOR *v, const char *name) {
-  // first, parse all of the names
-  int i, num_names = 0;
-  char **bits = parse_keywords(name, &num_names);
+  LIST    *bits = parse_keywords(name);
+  char *one_bit = NULL;
 
-  // set each one
-  for(i = 0; i < num_names; i++) {
-    int val = (int)hashGet(v->data->bitmap, bits[i]);
-    free(bits[i]);
+  // toggle each one
+  while( (one_bit = listPop(bits)) != NULL) {
+    int val = (int)hashGet(v->data->bitmap, one_bit);
+    free(one_bit);
     // 0 is a filler meaning 'this is not an actual name for a bit'
     if(val == 0) continue;
     TOGGLE_BIT(v->bits[val/8], (1 << (val % 8)));
   }
-  free(bits);
+
+  // garbage collection
+  deleteListWith(bits, free);
 }
 
 const char *bitvectorGetBits(BITVECTOR *v) {
diff -ruN ../nakedmudv3.0/src/body.c src/body.c
--- ../nakedmudv3.0/src/body.c	Fri Oct  7 14:15:55 2005
+++ src/body.c	Sun Dec  4 20:03:08 2005
@@ -112,23 +112,27 @@
 //*****************************************************************************
 
 char *list_postypes(const BODY_DATA *B, const char *posnames) {
-  int i, found, part, num_names = 0;
-  char **names  = parse_keywords(posnames, &num_names);
-  char types[MAX_BUFFER] = "\0";
-
-  for(i = found = 0; i < num_names; i++) {
-    part = bodyGetPart(B, names[i]);
-    free(names[i]);
+  LIST           *names = parse_keywords(posnames);
+  LIST_ITERATOR *name_i = newListIterator(names);
+  BUFFER           *buf = newBuffer(MAX_BUFFER);
+  char            *name = NULL;
+  char          *retval = NULL;
+  int             found = 0;
+
+  ITERATE_LIST(name, name_i) {
+    int part = bodyGetPart(B, name);
     if(part != BODYPOS_NONE) {
       found++;
       if(found != 1)
-	strcat(types, ", ");
-      strcat(types, bodyposGetName(part));
+	bufferCat(buf, ", ");
+      bufferCat(buf, bodyposGetName(part));
     }
-  }
-  if(names) free(names);
+  } deleteListIterator(name_i);
+  deleteListWith(names, free);
 
-  return strdup(types);
+  retval = strdup(bufferString(buf));
+  deleteBuffer(buf);
+  return retval;
 }
 
 const char *bodysizeGetName(int size) {
@@ -282,8 +286,7 @@
     if(pos && *pos && !is_keyword(pos, part->name, FALSE))
       continue;
     size_sum += part->size;
-  }
-  // dont' delete the iterator... we use it again below after resetting
+  } deleteListIterator(part_i);
 
   // nothing that can be hit was found
   if(size_sum <= 1) {
@@ -294,7 +297,7 @@
   pos_roll = rand_number(1, size_sum);
   
   // find the position the roll corresponds to
-  listIteratorReset(part_i);
+  part_i = newListIterator(B->parts);
   ITERATE_LIST(part, part_i) {
     // if we have a list of positions to draw from, only factor in those
     if(pos && *pos && !is_keyword(pos, part->name, FALSE))
@@ -304,8 +307,7 @@
       name = part->name;
       break;
     }
-  }
-  deleteListIterator(part_i);
+  } deleteListIterator(part_i);
   return name;
 }
 
@@ -333,8 +335,7 @@
       parts[i] = part->name;
       pos[i]   = part->type;
       i++;
-    }
-    deleteListIterator(part_i);
+    } deleteListIterator(part_i);
 
     // now sort everything in the array
     for(i = 0; i < *num_pos; i++) {
@@ -365,72 +366,88 @@
 
 
 bool bodyEquipPostypes(BODY_DATA *B, OBJ_DATA *obj, const char *types) {
-  int i, num_positions = 0;
-  char **pos_list = parse_keywords(types, &num_positions);
-  LIST     *parts = newList();
+  LIST  *pos_list = parse_keywords(types);
+  LIST     *parts = NULL;
   BODYPART  *part = NULL;
+  bool    success = TRUE;
 
   // make sure we have more than zero positions
-  if(num_positions < 1)
+  if(listSize(pos_list) == 0) {
+    deleteList(pos_list);
     return FALSE;
+  }
+
+  // create our list of parts
+  parts = newList();
 
   // get a list of all open slots in the list provided ...
   // equip them as we go along, incase we more than one of a piece.
   // if we don't do it this way, findFreeBodypart might find the same
   // piece multiple times (e.g. the same ear when it's looking for two ears)
-  for(i = 0; i < num_positions; i++) {
-    part = findFreeBodypart(B, pos_list[i]);
+  LIST_ITERATOR *pos_i = newListIterator(pos_list);
+  char            *pos = NULL;
+
+  ITERATE_LIST(pos, pos_i) {
+    part = findFreeBodypart(B, pos);
     if(part && !part->equipment) {
       part->equipment = obj;
       listPut(parts, part);
     }
-    free(pos_list[i]);
-  }
-  if(pos_list) free(pos_list);
+  } deleteListIterator(pos_i);
 
-  // make sure we supplied valid names
-  if(listSize(parts) != num_positions) {
-    // remove everything we put on
+  // make sure we supplied a valid number of empty positions
+  if(listSize(pos_list) != listSize(parts)) {
+    // remove equipment for every part we put it on
     while((part = listPop(parts)) != NULL)
       part->equipment = NULL;
-    deleteList(parts);
-    return FALSE;
+    success = FALSE;
   }
 
+  // garbage collection
+  deleteListWith(pos_list, free);
   deleteList(parts);
-  return TRUE;
+
+  return success;
 }
 
 
 bool bodyEquipPosnames(BODY_DATA *B, OBJ_DATA *obj, const char *positions) {
-  int i, num_positions = 0;
-  char **pos_list = parse_keywords(positions, &num_positions);
-  LIST  *parts = newList();
+  LIST *pos_list = parse_keywords(positions);
+  LIST    *parts = NULL;
   BODYPART *part = NULL;
+  bool   success = TRUE;
 
   // make sure we have more than zero positions
-  if(num_positions < 1)
+  if(listSize(pos_list) == 0) {
+    deleteList(pos_list);
     return FALSE;
+  }
+
+  // create our list of parts
+  parts = newList();
 
   // get a list of all open slots in the list provided
-  for(i = 0; i < num_positions; i++) {
-    part = findBodypart(B, pos_list[i]);
-    if(part && !part->equipment) listPut(parts, part);
-    free(pos_list[i]);
-  }
-  if(pos_list) free(pos_list);
+  LIST_ITERATOR *pos_i = newListIterator(pos_list);
+  char            *pos = NULL;
+  ITERATE_LIST(pos, pos_i) {
+    part = findBodypart(B, pos);
+    if(part && !part->equipment && !listIn(parts, part))
+      listPut(parts, part);
+  } deleteListIterator(pos_i);
 
-  // make sure we supplied valid names
-  if(listSize(parts) != num_positions || listSize(parts) < 1) {
-    deleteList(parts);
-    return FALSE;
-  }
+  // make sure we found the right amount of parts
+  if(listSize(parts) != listSize(pos_list) || listSize(parts) == 0)
+    success = FALSE;
 
   // fill in all of the parts that need to be filled
   while( (part = listPop(parts)) != NULL)
     part->equipment = obj;
+
+  // clean up our garbage
+  deleteListWith(pos_list, free);
   deleteList(parts);
-  return TRUE;
+
+  return success;
 }
 
 const char *bodyEquippedWhere(BODY_DATA *B, OBJ_DATA *obj) {
@@ -455,7 +472,7 @@
 
 OBJ_DATA *bodyGetEquipment(BODY_DATA *B, const char *pos) {
   BODYPART *part = findBodypart(B, pos);
-  return part->equipment;
+  return (part ? part->equipment : NULL);
 }
 
 bool bodyUnequip(BODY_DATA *B, const OBJ_DATA *obj) {
diff -ruN ../nakedmudv3.0/src/buffer.c src/buffer.c
--- ../nakedmudv3.0/src/buffer.c	Fri Oct  7 14:15:55 2005
+++ src/buffer.c	Sun Dec  4 20:03:07 2005
@@ -25,6 +25,7 @@
 
 BUFFER    *newBuffer   (int start_capacity) {
   BUFFER *buf = malloc(sizeof(BUFFER));
+  if(start_capacity <= 0) start_capacity = 1;
   buf->data   = malloc(sizeof(char) * start_capacity);
   *buf->data  = '\0';
   buf->maxlen = start_capacity;
@@ -206,7 +207,6 @@
     return 0;
 }
 
-
 void bufferFormat(BUFFER *buf, int max_width, int indent) {
   char formatted[(buf->len * 3)/2];
   bool needs_capital = TRUE, needs_indent = FALSE;
@@ -225,13 +225,12 @@
       buf_i++;
   }
 
-
   for(; buf->data[buf_i] != '\0'; buf_i++) {
     // we have to put a newline in because the word won't fit on the line
     next_space = next_space_in(buf->data + buf_i);
     if(next_space == -1)
       next_space = buf->len - buf_i;
-    if(col + next_space > max_width-2) {
+    if(col + next_space > max_width-1) {
       formatted[fmt_i] = '\r'; fmt_i++;
       formatted[fmt_i] = '\n'; fmt_i++;
       col = 0;
@@ -239,8 +238,8 @@
 
     char ch = buf->data[buf_i];
 
-    // no spaces on newlines
-    if(isspace(ch) && col == 0)
+    // no spaces on newlines or ends of lines
+    if(isspace(ch) && (col == 0 || col == max_width-1))
       continue;
     // we will do our own sentance formatting
     else if(needs_capital && isspace(ch))
@@ -259,7 +258,7 @@
     }
     // if someone is putting more than 1 sentence delimiter, we
     // need to catch it so we will still capitalize the next word
-    else if(strchr("?!.", ch)) {
+    else if(strchr("?!.", ch) && isspace(buf->data[buf_i + 1])) {
       needs_capital = TRUE;
       needs_indent  = TRUE;
       formatted[fmt_i] = ch;
@@ -273,7 +272,7 @@
       next_space = next_space_in(buf->data + buf_i);
       if(next_space == -1)
 	next_space = buf->len - buf_i;
-      if(col + 2 + next_space > max_width-2) {
+      if(col + 2 + next_space > max_width-1) {
 	formatted[fmt_i] = '\r'; fmt_i++;
 	formatted[fmt_i] = '\n'; fmt_i++;
 	col = 0;
@@ -292,7 +291,11 @@
     }
     else {
       formatted[fmt_i] = ch;
-      col++;
+     
+      // if we're adding a { or our last character was an {, don't increase
+      // our columns, because these are colour codes
+      if(ch != '{' && (fmt_i == 0 || formatted[fmt_i-1] != '{'))
+	col++;
     }
 
     fmt_i++;
@@ -305,6 +308,12 @@
   }
 
   formatted[fmt_i] = '\0';
+
+  // if all we have are spaces and newlines, erase it all
+  if(fmt_i == 2 + indent) {
+    formatted[0] = '\0';
+    fmt_i = 0;
+  }
 
   // make sure we have enough room to copy everything over
   if(fmt_i >= buf->maxlen)
diff -ruN ../nakedmudv3.0/src/char_gen.c src/char_gen.c
--- ../nakedmudv3.0/src/char_gen.c	Fri Oct  7 14:15:55 2005
+++ src/char_gen.c	Sun Dec  4 20:03:07 2005
@@ -167,6 +167,9 @@
     // we should do some checks here to make sure the start room exists
     char_to_room(socketGetChar(sock), worldGetRoom(gameworld, START_ROOM));
     look_at_room(socketGetChar(sock), charGetRoom(socketGetChar(sock)));
+
+    // run any hooks for creating the player for the first time
+    hookRun("create_player", socketGetChar(sock));
     
     // and register him as a valid player
     register_player(socketGetChar(sock));
@@ -180,7 +183,7 @@
 
     // run entrance hooks
     ROOM_DATA      *room = charGetRoom(socketGetChar(sock));
-    hookRun("enter", socketGetChar(sock), room, NULL);
+    hookRun("enter", socketGetChar(sock), room);
   }
 }
 
diff -ruN ../nakedmudv3.0/src/char_vars/.depend src/char_vars/.depend
--- ../nakedmudv3.0/src/char_vars/.depend	Wed Dec 31 17:00:00 1969
+++ src/char_vars/.depend	Sun Dec  4 20:03:07 2005
@@ -0,0 +1 @@
+char_vars.o: char_vars.c char_vars.h
diff -ruN ../nakedmudv3.0/src/cmd_admin.c src/cmd_admin.c
--- ../nakedmudv3.0/src/cmd_admin.c	Fri Oct  7 14:15:55 2005
+++ src/cmd_admin.c	Sun Dec  4 20:03:07 2005
@@ -82,9 +82,8 @@
     send_to_char(ch,"The mud currently has %d pulses per second.\r\n", 
 		 PULSES_PER_SECOND);
   else {
-    int pulserate = 0;
-    if(!parse_args(ch, FALSE, cmd, arg, "int",  &pulserate) ||
-       (1000 % pulserate != 0))
+    int pulserate = atoi(arg);
+    if(pulserate == 0 || 1000 % pulserate != 0)
       send_to_char(ch, "The number of pulses per second must divide 1000.\r\n");
     else {
       mudsettingSetInt("pulses_per_second", pulserate);
diff -ruN ../nakedmudv3.0/src/cmd_builder.c src/cmd_builder.c
--- ../nakedmudv3.0/src/cmd_builder.c	Fri Oct  7 14:15:55 2005
+++ src/cmd_builder.c	Sun Dec  4 20:03:07 2005
@@ -218,19 +218,28 @@
 // Functions for deleting different prototype
 //*****************************************************************************
 COMMAND(cmd_rdelete) {
-  if(do_delete(ch, "rproto", deleteProto, arg)) {
-    do_delete(ch, "reset", deleteResetList, arg);
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  if(do_delete(ch, "rproto", deleteProto, name)) {
+    do_delete(ch, "reset", deleteResetList, name);
     send_to_char(ch, "If the room has already been used, do not forget to "
 		 "also purge the current instance of it.\r\n");
   }
 }
 
 COMMAND(cmd_mdelete) {
-  do_delete(ch, "mproto", deleteProto, arg);
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  do_delete(ch, "mproto", deleteProto, name);
 }
 
 COMMAND(cmd_odelete) {
-  do_delete(ch, "oproto", deleteProto, arg);
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  do_delete(ch, "oproto", deleteProto, name);
 }
 
 
@@ -242,7 +251,7 @@
 // returns yes/no if the prototype is abstract or not
 const char *prototype_list_info(PROTO_DATA *data) {
   static char buf[SMALL_BUFFER];
-  sprintf(buf, "%-40s %13s", 
+  sprintf(buf, "%-50s %3s", 
 	  (*protoGetParents(data) ? protoGetParents(data) : "-------"),
 	  (protoIsAbstract(data)  ? "yes" : "no"));
   return buf;
@@ -269,25 +278,28 @@
 }
 
 COMMAND(cmd_mrename) {
-  char from[SMALL_BUFFER];
-  arg = one_arg(arg, from);
-  do_rename(ch, "mproto", from, arg);
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  do_rename(ch, "mproto", from, to);
 }
 
 COMMAND(cmd_rrename) {
-  char from[SMALL_BUFFER];
-  arg = one_arg(arg, from);
-  if(do_rename(ch, "rproto", from, arg)) {
-    do_rename(ch, "reset", from, arg);
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  if(do_rename(ch, "rproto", from, to)) {
+    do_rename(ch, "reset", from, to);
     send_to_char(ch, "No not forget to purge any instances of %s already "
 		 "loaded.\r\n", from); 
   }
 }
 
 COMMAND(cmd_orename) {
-  char from[SMALL_BUFFER];
-  arg = one_arg(arg, from);
-  do_rename(ch, "oproto", from, arg);
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  do_rename(ch, "oproto", from, to);
 }
 
 COMMAND(cmd_zlist) {
diff -ruN ../nakedmudv3.0/src/cmd_comm.c src/cmd_comm.c
--- ../nakedmudv3.0/src/cmd_comm.c	Fri Oct  7 14:15:55 2005
+++ src/cmd_comm.c	Sun Dec  4 20:03:07 2005
@@ -89,7 +89,7 @@
     send_to_char(ch, "Say what?\n\r");
   else {
     communicate(ch, arg, COMM_LOCAL);
-    hookRun("say", ch, NULL, arg);
+    hookRun("say", ch, arg);
   }
 }
 
@@ -107,10 +107,10 @@
   if(!parse_args(ch, TRUE, cmd, arg, "ch.room.noself", &tgt))
     return;
 
-  message(ch, tgt, NULL, NULL, FALSE, TO_CHAR, "{wYou greet $N.");
-  message(ch, tgt, NULL, NULL, FALSE, TO_VICT, "{w$n greets you.");
+  message(ch, tgt, NULL, NULL, FALSE, TO_CHAR, "You greet $N.");
+  message(ch, tgt, NULL, NULL, FALSE, TO_VICT, "$n greets you.");
   message(ch, tgt, NULL, NULL, FALSE, TO_ROOM, "$n greets $N.");
-  hookRun("greet", ch, tgt, NULL);
+  hookRun("greet", ch, tgt);
 }
 
 
diff -ruN ../nakedmudv3.0/src/cmd_manip.c src/cmd_manip.c
--- ../nakedmudv3.0/src/cmd_manip.c	Fri Oct  7 14:15:55 2005
+++ src/cmd_manip.c	Sun Dec  4 20:03:07 2005
@@ -17,6 +17,7 @@
 #include "world.h"
 #include "room.h"
 #include "object.h"
+#include "hooks.h"
 
 
 
@@ -126,8 +127,7 @@
       exitSetLocked(found, TRUE);
 
       // and try the other side
-      try_manip_other_exit(charGetRoom(ch), found, exitIsClosed(found),
-			   TRUE);
+      try_manip_other_exit(charGetRoom(ch), found, exitIsClosed(found), TRUE);
     }
   }
 
@@ -181,8 +181,7 @@
       exitSetLocked(found, FALSE);
 
       // and try the other side
-      try_manip_other_exit(charGetRoom(ch), found, exitIsClosed(found),
-			   FALSE);
+      try_manip_other_exit(charGetRoom(ch), found, exitIsClosed(found), FALSE);
     }
   }
 
@@ -283,6 +282,7 @@
 
       // try opening the other side
       try_manip_other_exit(charGetRoom(ch), found, FALSE, exitIsLocked(found));
+      hookRun("open_door", ch, found);
     }
   }
 
@@ -299,6 +299,7 @@
       send_to_char(ch, "You open %s.\r\n", objGetName(found));
       message(ch, NULL, found, NULL, FALSE, TO_ROOM, "$n opens $o.");
       containerSetClosed(found, FALSE);
+      hookRun("open_obj", ch, found);
     }
   }
 }
@@ -523,7 +524,7 @@
   bool multiple = FALSE;
   char   *where = NULL;
 
-  if(!parse_args(ch, TRUE, cmd, arg, "[the] obj.inv.multiple | [on my] string", 
+  if(!parse_args(ch, TRUE, cmd, arg, "[the] obj.inv.multiple | [on] string", 
 		 &found, &multiple, &where))
     return;
 
diff -ruN ../nakedmudv3.0/src/command.c src/command.c
--- ../nakedmudv3.0/src/command.c	Fri Oct  7 14:15:55 2005
+++ src/command.c	Sun Dec  4 20:03:07 2005
@@ -21,6 +21,7 @@
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
+#include "scripts/scripts.h"
 #include "scripts/pyplugs.h"
 #include "scripts/pychar.h"
 
@@ -207,7 +208,8 @@
     if(cmd->func)
       (cmd->func)(ch, cmd->name, arg);
     else {
-      PyObject *arglist = Py_BuildValue("Oss", newPyChar(ch), cmd->name, arg);
+      PyObject *arglist = Py_BuildValue("Oss", charGetPyFormBorrowed(ch), 
+					cmd->name, arg);
       PyObject *retval  = PyEval_CallObject(cmd->pyfunc, arglist);
       // check for an error:
       if(retval == NULL) {
@@ -218,6 +220,8 @@
 	  free(tb);
 	}
       }
+
+      // garbage collection
       Py_XDECREF(retval);
       Py_XDECREF(arglist);
     }
diff -ruN ../nakedmudv3.0/src/event.c src/event.c
--- ../nakedmudv3.0/src/event.c	Fri Oct  7 14:15:55 2005
+++ src/event.c	Sun Dec  4 20:03:07 2005
@@ -96,11 +96,6 @@
     event->on_complete(event->owner, event->data, event->arg);
 }
 
-// the hook for interrupting events when something is removed from game
-void interrupt_events_hook(void *thing, void *none1, void *none2) {
-  interrupt_events_involving(thing);
-}
-
 
 
 //*****************************************************************************
@@ -115,9 +110,9 @@
 
   // make sure all events involving the object/char are cancelled when
   // either is extracted from the game
-  hookAdd("obj_from_game",  interrupt_events_hook);
-  hookAdd("char_from_game", interrupt_events_hook);
-  hookAdd("room_from_game", interrupt_events_hook);
+  hookAdd("obj_from_game",  interrupt_events_involving);
+  hookAdd("char_from_game", interrupt_events_involving);
+  hookAdd("room_from_game", interrupt_events_involving);
 }
 
 void interrupt_event(EVENT_DATA *event) {
diff -ruN ../nakedmudv3.0/src/exit.c src/exit.c
--- ../nakedmudv3.0/src/exit.c	Fri Oct  7 14:15:55 2005
+++ src/exit.c	Sun Dec  4 20:03:07 2005
@@ -28,6 +28,7 @@
   char *to;                // where do we exit to?
   char *key;               // what is the key's prototype?
   BUFFER *desc;            // what does a person see when they look at us?
+  ROOM_DATA *room;         // the room we're attached to
 
   char *spec_enter;        // the message when we enter from this exit
   char *spec_leave;        // the message when we leave through this exit
@@ -56,6 +57,7 @@
   exit->pick_lev    = 0;
   exit->status      = 0;
   exit->closable    = FALSE;
+  exit->room        = NULL;
   exit->uid         = next_exit_uid++;
   return exit;
 };
@@ -200,6 +202,10 @@
   return exit->desc;
 }
 
+ROOM_DATA *exitGetRoom(const EXIT_DATA *exit) {
+  return exit->room;
+}
+
 void        exitSetClosable(EXIT_DATA *exit, bool closable) {
   exit->closable = (closable != 0);
 }
@@ -260,4 +266,8 @@
 void        exitSetSpecLeave(EXIT_DATA *exit, const char *leave) {
   if(exit->spec_leave)  free(exit->spec_leave);
   exit->spec_leave    = strdupsafe(leave);
+}
+
+void exitSetRoom(EXIT_DATA *exit, ROOM_DATA *room) {
+  exit->room = room;
 }
diff -ruN ../nakedmudv3.0/src/exit.h src/exit.h
--- ../nakedmudv3.0/src/exit.h	Fri Oct  7 14:15:55 2005
+++ src/exit.h	Sun Dec  4 20:03:07 2005
@@ -65,6 +65,7 @@
 const char *exitGetSpecLeave   (const EXIT_DATA *exit);
 const char *exitGetSpecEnter   (const EXIT_DATA *exit);
 BUFFER     *exitGetDescBuffer  (const EXIT_DATA *exit);
+ROOM_DATA  *exitGetRoom        (const EXIT_DATA *exit);
 
 void        exitSetClosable    (EXIT_DATA *exit, bool closable);
 void        exitSetClosed      (EXIT_DATA *exit, bool closed);
@@ -79,5 +80,6 @@
 void        exitSetDesc        (EXIT_DATA *exit, const char *desc);
 void        exitSetSpecLeave   (EXIT_DATA *exit, const char *leave);
 void        exitSetSpecEnter   (EXIT_DATA *exit, const char *enter);
+void        exitSetRoom        (EXIT_DATA *exit, ROOM_DATA *room);
 
 #endif // __EXIT_H
diff -ruN ../nakedmudv3.0/src/gameloop.c src/gameloop.c
--- ../nakedmudv3.0/src/gameloop.c	Fri Oct  7 14:15:55 2005
+++ src/gameloop.c	Sun Dec  4 20:03:07 2005
@@ -23,6 +23,7 @@
 #include "auxiliary.h"
 #include "storage.h"
 #include "races.h"
+#include "inform.h"
 #include "hooks.h"
 
 
@@ -172,6 +173,9 @@
   log_string("Initializing races and default bodies.");
   init_races();
 
+  log_string("Initializing inform system.");
+  init_inform();
+
   log_string("Initializing room resets.");
   init_room_reset();
 
@@ -299,7 +303,7 @@
   game_loop(control);
 
   // run our finalize hooks
-  hookRun("shutdown", NULL, NULL, NULL);
+  hookRun("shutdown");
 
   // close down the socket
   close(control);
